import { HttpStatus } from "@nestjs/common";
import { JwtService } from "@nestjs/jwt";
import { UserRolesService } from "./user-roles/user-roles.service";
import { UsersService } from "./users/users.service";
export declare class AuthService {
    private jwtService;
    private userService;
    private userRoleService;
    constructor(jwtService: JwtService, userService: UsersService, userRoleService: UserRolesService);
    validateUser(username: string, pass: string): Promise<any>;
    findUser(username: string): Promise<any>;
    tokenDecode(token: string): Promise<any>;
    login(user: any): Promise<{
        statusCode: HttpStatus;
        message: string;
        success: boolean;
        access_token: string;
    } | {
        statusCode: HttpStatus;
        success: boolean;
        message: string;
        access_token?: undefined;
    }>;
}
