"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const jwt_1 = require("@nestjs/jwt");
const user_roles_service_1 = require("./user-roles/user-roles.service");
const users_service_1 = require("./users/users.service");
let AuthService = class AuthService {
    constructor(jwtService, userService, userRoleService) {
        this.jwtService = jwtService;
        this.userService = userService;
        this.userRoleService = userRoleService;
    }
    validateUser(username, pass) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.userService.findByUsername(username);
            if (user && user.success && user.result.password === pass) {
                const plainUser = user.result.get({ plain: true });
                delete plainUser.password;
                return Object.assign({}, plainUser);
            }
            else
                return { message: "Failed" };
        });
    }
    findUser(username) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.userService.findByUsername(username);
            if (user && user.success) {
                const plainUser = user.result.get({ plain: true });
                delete plainUser.password;
                return plainUser;
            }
        });
    }
    tokenDecode(token) {
        return __awaiter(this, void 0, void 0, function* () {
            const authHeaders = token;
            if (authHeaders && authHeaders.split(" ")[1]) {
                const token = authHeaders.split(" ")[1];
                const decoded = this.jwtService.decode(token);
                const user = yield this.userService.findByUsername(decoded.UserName);
                const plainUser = user.result.get({ plain: true });
                delete plainUser.password;
                return plainUser;
            }
        });
    }
    login(user) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!user.message) {
                const payload = { UserName: user.email, ID: user.id };
                return {
                    statusCode: common_1.HttpStatus.OK,
                    message: "success",
                    success: true,
                    access_token: this.jwtService.sign(payload),
                };
            }
            else
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    success: false,
                    message: "Invalid Username or Password",
                };
        });
    }
};
AuthService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [jwt_1.JwtService,
        users_service_1.UsersService,
        user_roles_service_1.UserRolesService])
], AuthService);
exports.AuthService = AuthService;
